#!/usr/bin/env python

def myexec(cmd):
	import os
	import sys
	print  "	 ", cmd
	r = os.system(cmd)
	if r != 0:
		print "Command execution failed!"
		print "If it failed at wget or curl due to no Internet connection, try download the file from other machine,",
		print "copy it to the current directory and restart install_mpi.py.",
		print "Otherwise, check the log file and try to resolve it."
		sys.exit(-1)


def chdir(dir):
	import os
	print  "	  cd ", dir
	os.chdir(dir)


def macos():
	import commands
	r = commands.getoutput("uname")
	return r=="Darwin"


def geturl(url, file):
	import os, sys
	import commands

	if macos():
		myexec("curl " + url + " -o " + file)
	else:
		myexec("wget " + url)
	# sys.exit(0)

def get_mpiroot(options):
	import os
	import commands
	if options.force:
		return False
	print "Checking mpicc"
		
	r = os.system("mpicc --version")
	if r != 0:
		print "Cannot find mpicc"
		return False
		
	return True
	

def get_numpyroot(pythonroot):
	try:
		import numpy
		return pythonroot 

	except Exception, inst:
		print "problem import numpy:", inst
		return None


def install_openmpi(version):
	import os
	root = os.environ['EMAN2DIR']

	pwd = os.getcwd()

	#file = "openmpi-1.6.4.tar.gz"
	#url = "http://www.open-mpi.org/software/ompi/v1.6/downloads/" + file

	file = "openmpi-%s.tar.gz"%version
	major_version = version.split(".")
	major_version =  major_version[0] + "." + major_version[1]
	if macos():
		url = " https://www.open-mpi.org/software/ompi/v%s/downloads/"%major_version  + file
	else:
		url = " --no-check-certificate  https://www.open-mpi.org/software/ompi/v%s/downloads/"%major_version  + file
	
	print ""
	print "Installing openmpi-%s"%version
	if not(os.path.exists("openmpi-%s"%version)) :
		if not(os.path.exists(file)):
			geturl(url, file)
		myexec("tar -zxf " + file)
		
	chdir("openmpi-%s"%version)
	myexec("./configure --enable-static --prefix=" + root + " --disable-dlopen")
	myexec("make clean >> log")
	myexec("make >> log")
	myexec("make install >> log")
	os.chdir(pwd)
	return root


from optparse import OptionParser
import string

default_version_of_open_mpi_to_istall = "1.10.2"

usage = "install_mpi.py --force --openmpi_ver=%s"%default_version_of_open_mpi_to_istall
parser = OptionParser(usage)
parser.add_option( "--force", action="store_true", default=False, help="forcefully install necessary packages" )
parser.add_option("--openmpi_ver", type="string",  default=default_version_of_open_mpi_to_istall, help="version of openmpi to forcefully install, default = %s"%default_version_of_open_mpi_to_istall)
options,args = parser.parse_args()

import os
from sys import exit
import commands

try:
	eman2 = os.environ['EMAN2DIR']
except:
	print "Error: cannot find EMAN2DIR environment variable, cannot proceed! You have to install EMAN2 first."
	exit(-1)

try:
	# Try to fix problem with dependencies caused by EMAN2 - sometimes it is needed to make configure scripts work
	ld_library_path = os.environ["LD_LIBRARY_PATH"]
	os.environ["LD_LIBRARY_PATH"] = string.replace(ld_library_path, eman2 + "/lib:", "")
except:
	pass

path_to_python = eman2 + "/Python/bin/python"

#pythonroot, python_version = get_pythonroot(options)
if not get_mpiroot(options):
	if options.force:
		print ""
		print "=====> Install OpenMPI version %s"%options.openmpi_ver
		install_openmpi(options.openmpi_ver)
	else:
		print "You need MPI environment (both runtime and developer packages) and gcc compiler to continue. "
		print "If you work on professional HPC cluster, in all likelihood both are already installed. "
		print "In this case read the user guide - you have to probably load appriopriate module by \"module load\" command."
		print "You can also run this script again with the --force option - it will download and install MPI (openmpi-1.6.4) for you."
		exit(-1)

print ""
print "=====> Configuring the mpi python binding"

if os.path.exists(eman2 + "/Python"):
	myexec("./configure --with-python=" + eman2 + "/Python/bin/python --prefix=" + eman2)
else:
	# EMAN2 doesn't have Python - default one will be used
	myexec("./configure --prefix=" + eman2)
		
print ""
print "=====> Building the mpi python binding"
myexec("make clean >> log.txt")	
myexec("make all >> log.txt")	

print ""
print "=====> Install the mpi python binding"
myexec("make install >> log.txt")	

print ""
print "=====> Installation complete successfully!"
